#define DictCreator 'TPdb'    /* creator ID, also used in the makefile */
#define DictType    'DATA'    /* type of database */
#define DictVersion 01        /* version number */
#define DictStatCreator 'TPst'	/* creator ID for Status */
#define DE_BUFFER_SIZE	1024	/* decompress buffer size */
#define MAX_RECORD_SIZE	65505	/* Max record size */

#define DELIMITER '#'
#define TYPE_DELIMITER ':'
#define ADDR_DELIMITER '@'

#define ESCAPE '\\'

#define emptyRecordLabel	"-empty-"

typedef struct  {
	UInt16  WordRecTotal;
	UInt16  MeanRecTotal;
	UInt16  lastWordPtr;
	UInt16  lastWordRec;

	Char padding[504]; /* exactly 512 bytes */
} DictAppInfoType;

/* The structure stored as the application preferences */
typedef struct {
  char lastDictName[dmDBNameLength];
} DictPreferences;

/*
DictTableInfo - Ѻ红ŷ ʴ˹Ҩͤ 10 records
	word : Ѿ
	word_type : ҹ, 
	word_record_number : Ѿҡ record ?
	ptr_in_record : ˹觢ͧѷ record
	mean_record_number :  record ?
	mean_offset : ˹觢ͧ record
	mean_size : Ǣͧ (ѡ)
*/

typedef struct
{
	char  word[64];
	char  word_type[64];
	UInt16  word_record_number;
	char  *ptr_in_record;
	char  mean_record_number;
	UInt16  mean_offset;
	UInt16  mean_size;
} DictTableInfo;

typedef struct
{
	char  *word_ptr;
	char  *word_buf;

	char  *mean_ptr;
	char  *mean_buf;

	char  *select_word_ptr;

	UInt16  word_buf_size;
	UInt16  mean_buf_size;

	UInt16  select_idx;
	UInt16  last_idx;

	UInt16  start_word_record;
	UInt16  end_word_record;
	UInt16  start_mean_record;
	UInt16  end_mean_record;
	UInt16  records_total;

	UInt16  current_word_record;
	UInt16  current_mean_record;

	DictTableInfo  word_table[wordTableRows];
	UInt16  select_word_record;

	UInt16  de_word_record;	// Decompress word record
	UInt16  de_mean_record; // Decompress mean record

	Boolean lastpage;
} GlobalData;

/*  Global */
extern char DictDBName[];
extern UInt16 ViewPage;
extern char ViewTitle[];

extern GlobalData gd;
extern FormPtr mainform;

/* Prototypes */
Err StartApplication(void);
void EventLoop(void);
void StopApplication(void);
Boolean FormDictMainHandler(EventPtr event);
void ShowMessageDialog(UInt16 fid);

void ReadDatabaseInfo();
void CloseDatabase();
void WordTableDrawRecord(MemPtr table, UInt16 row, UInt16 column, RectanglePtr bounds );
UInt16 LoadData2Array();
UInt16 LoadWordTable();
void DictDrawEntry( UInt16 row, RectanglePtr bounds);
Boolean QuickScroll( EventPtr event );
Err GoBack(int item, char *start);
Err LoadWordRecord(int recordNo, Boolean showstat);
Err LoadMeanRecord(int recordNo, Boolean showstat);
Err decompress_record(UInt16 recno, Boolean showstat);

Boolean FormMeanViewHandler(EventPtr event);
